<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUploadedPanelSetting ArrayType
 * @subpackage Arrays
 */
class ArrayOfUploadedPanelSetting extends AbstractStructArrayBase
{
    /**
     * The UploadedPanelSetting
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\UploadedPanelSetting[]
     */
    public $UploadedPanelSetting;
    /**
     * Constructor method for ArrayOfUploadedPanelSetting
     * @uses ArrayOfUploadedPanelSetting::setUploadedPanelSetting()
     * @param \CustomerManagement\StructType\UploadedPanelSetting[] $uploadedPanelSetting
     */
    public function __construct(array $uploadedPanelSetting = array())
    {
        $this
            ->setUploadedPanelSetting($uploadedPanelSetting);
    }
    /**
     * Get UploadedPanelSetting value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\UploadedPanelSetting[]|null
     */
    public function getUploadedPanelSetting()
    {
        return isset($this->UploadedPanelSetting) ? $this->UploadedPanelSetting : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUploadedPanelSetting method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUploadedPanelSetting method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUploadedPanelSettingForArrayConstraintsFromSetUploadedPanelSetting(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUploadedPanelSettingUploadedPanelSettingItem) {
            // validation for constraint: itemType
            if (!$arrayOfUploadedPanelSettingUploadedPanelSettingItem instanceof \CustomerManagement\StructType\UploadedPanelSetting) {
                $invalidValues[] = is_object($arrayOfUploadedPanelSettingUploadedPanelSettingItem) ? get_class($arrayOfUploadedPanelSettingUploadedPanelSettingItem) : sprintf('%s(%s)', gettype($arrayOfUploadedPanelSettingUploadedPanelSettingItem), var_export($arrayOfUploadedPanelSettingUploadedPanelSettingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UploadedPanelSetting property can only contain items of type \CustomerManagement\StructType\UploadedPanelSetting, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UploadedPanelSetting value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\UploadedPanelSetting[] $uploadedPanelSetting
     * @return \CustomerManagement\ArrayType\ArrayOfUploadedPanelSetting
     */
    public function setUploadedPanelSetting(array $uploadedPanelSetting = array())
    {
        // validation for constraint: array
        if ('' !== ($uploadedPanelSettingArrayErrorMessage = self::validateUploadedPanelSettingForArrayConstraintsFromSetUploadedPanelSetting($uploadedPanelSetting))) {
            throw new \InvalidArgumentException($uploadedPanelSettingArrayErrorMessage, __LINE__);
        }
        if (is_null($uploadedPanelSetting) || (is_array($uploadedPanelSetting) && empty($uploadedPanelSetting))) {
            unset($this->UploadedPanelSetting);
        } else {
            $this->UploadedPanelSetting = $uploadedPanelSetting;
        }
        return $this;
    }
    /**
     * Add item to UploadedPanelSetting value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\UploadedPanelSetting $item
     * @return \CustomerManagement\ArrayType\ArrayOfUploadedPanelSetting
     */
    public function addToUploadedPanelSetting(\CustomerManagement\StructType\UploadedPanelSetting $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\UploadedPanelSetting) {
            throw new \InvalidArgumentException(sprintf('The UploadedPanelSetting property can only contain items of type \CustomerManagement\StructType\UploadedPanelSetting, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UploadedPanelSetting[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\UploadedPanelSetting|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\UploadedPanelSetting|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\UploadedPanelSetting|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\UploadedPanelSetting|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\UploadedPanelSetting|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UploadedPanelSetting
     */
    public function getAttributeName()
    {
        return 'UploadedPanelSetting';
    }
}
